import librosa
import matplotlib.pyplot as plt
import os

def plot_waveforms(audio_dir, filenames):
    plt.figure(figsize=(20, 10))

    for i, filename in enumerate(filenames, start=1):
        # Construct the full path to the audio file
        filepath = os.path.join(audio_dir, filename)
        
        # Load the audio file
        y, sr = librosa.load(filepath, sr=None)  # sr=None to preserve the original sampling rate
        
        # Plot the waveform
        plt.subplot(4, 1, i)
        plt.plot(y)
        plt.title(f'Waveform of {filename}')
        plt.xlabel('Time')
        plt.ylabel('Amplitude')
    
    plt.tight_layout()
    plt.show()

audio_dir = 'data/audio1d'
filenames = ['mix.mp3', 'true.mp3', '6layer.wav', '3layer.wav']

plot_waveforms(audio_dir, filenames)