import numpy as np
import matplotlib.pyplot as plt

def normalize_denormalize_stft(stft_dir):

  # Load STFT
  stft = np.load(stft_dir)

  plt.subplot(1,3,1)
  plt.title('Original STFT')
  plt.imshow(stft.T, aspect='auto', origin='lower')

  mean = np.mean(stft)
  std = np.std(stft)
  stft_norm = (stft - mean) / std

  plt.subplot(1,3,2)
  plt.title('Normalized STFT')
  plt.imshow(stft_norm.T, aspect='auto', origin='lower')


  stft_denorm = stft_norm * std + mean


  plt.subplot(1,3,3)
  plt.title('De-normalized STFT')
  plt.imshow(stft_denorm.T, aspect='auto', origin='lower')

  print("Original and de-normalized STFT are the same:", np.allclose(stft, stft_denorm))
  
  plt.tight_layout()
  plt.show()

if __name__ == "__main__":
  file_dir = r'data\preprocessing_trial_trimmed_stft_1024\Mixture\0_Mixture.npy'
  normalize_denormalize_stft(file_dir)